services:
  - docker:24.0.6-dind

stages:
  - test
  - build
  - deploy

# Run flake8 to check for code quality
lint-test-job:
  image: python:3-bullseye
  stage: test
  script:
    - pip install flake8
    - flake8 api
  retry:
    max: 2
    when:
      - runner_system_failure

# Run the unit tests
api-unit-tests-job:
  image: python:3-bullseye
  stage: test
  variables:
    SIGNING_KEY: bxUeIEV9aWxZHjNo_jS_3oCL1z8mUA7YuEEBGCPyRkwBck2z8gs5L5NwLralUGPt_KAJM66fWM9yRthPSAHuhA
    DATABASE_URL: postgresql://postgres:password@postgres/postgresdb
  needs:
    - lint-test-job
  script:
    - echo $DATABASE_URL
    - cd api
    - pip install -r requirements.txt
    - python -m pytest
  retry:
    max: 2
    when:
      - runner_system_failure
# Build API Image:
build-api-image:
  stage: build
  image: docker:git
  variables:
    GITLAB_IMAGE: ${CI_REGISTRY_IMAGE}/api
  before_script:
    # $CI_JOB_TOKEN is variable automatically added by Gitlab: see https://docs.gitlab.com/ee/ci/variables/predefined_variables.html#variables-reference
    - echo $CI_JOB_TOKEN | docker login -u gitlab-ci-token registry.gitlab.com --password-stdin
  script:
    - docker system prune -af
    - docker build --tag $GITLAB_IMAGE:latest ./api
    - docker push $GITLAB_IMAGE:latest
  retry:
    max: 2
    when:
      - runner_system_failure
  only:
    - main
# Build the React/JavaScript front-end
build-front-end-job:
  stage: build
  image: node:lts-bullseye
  needs:
    - lint-test-job
  variables:
    # If either of these variables is defined in the GitLab
    # CI/CD variables, that value will override the value here.
    # You need to substitute in your real values for
    # GROUP_NAME, PROJECT_NAME, & WEBSERVICE_NAME below.
    # Don't forget to also replace PROJECT NAME in the npm run build line as well
    VITE_PUBLIC_URL: https://midi-fantastic-five1-28f57ed7ec62de863aeaf7a768417279982a32b577.gitlab.io
    VITE_APP_API_HOST: https://aug-2023-4-pt-api.mod3projects.com
  script:
    - cd ghi
    - npm install
    - npm run lint
    - npm run build
    # The following line creates a _redirects file to redirect all URLs to index.html
    # Documentation: https://docs.gitlab.com/ee/user/project/pages/redirects.html#rewrite-all-requests-to-a-root-indexhtml
    - echo "/* /index.html 200" > dist/_redirects
  artifacts:
    paths:
      - ghi/dist/
# Deploy the React/JavaScript front-end to GitLab pages
pages:
  stage: deploy
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
  dependencies:
    - build-front-end-job
  needs:
    - build-front-end-job
  script:
    - mv ghi/dist/ public
  artifacts:
    paths:
      - public
